Bug 1299599 - [gcc] Compilations fails with 'expected unqualified-id before token' when code contains vector class and macro and local var sharing same name
[gcc] Compilations fails with 'expected unqualified-id before token' when cod...
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
ppc64le Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
Depends On:
Blocks: PPCTracker F-ExcludeArch-ppc64le/PPC64LETracker
  Show dependency treegraph
Reported: 2016-01-18 12:44 EST by Rafael Fonseca
Modified: 2017-08-08 08:40 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2017-08-08 08:40:34 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
gcc/ppc64le error reproducer (898 bytes, text/x-csrc)
2016-01-18 12:44 EST, Rafael Fonseca
no flags Details

External Trackers
Tracker ID Priority Status Summary Last Updated
GNU Compiler Collection 70296 None None None 2016-03-18 10:38 EDT

  None (edit)
Description Rafael Fonseca 2016-01-18 12:44:16 EST
Created attachment 1115927 [details]
gcc/ppc64le error reproducer

Description of problem: qucs fails to build on ppc64le [1]. The reason seems to be that during preprocessing, gcc strips out the variable name. And that seems to happen because there is a local variable of the type 'vector' named the same as a macro.

The attached test case reproduces the issue.

[1] http://ppc.koji.fedoraproject.org/kojifiles/work/tasks/7101/3077101/build.log

Version-Release number of selected component (if applicable): 5.3.1-2

How reproducible: always when building qucs on ppc64le-koji. Always when compiling attached code on ppc64le.

Steps to Reproduce:
1. g++ test.cpp

Actual results: test.cpp:59:11: error: expected unqualified-id before ‘=’ token
  vector R = sqrt(C * C) + test(C);

In the processed file:

main(int argc, char *argv[])
 int C = -1;
 vector = sqrt(C * C) + test(C);

 cout << C << " " << R << endl;

 return 0;

Expected results: compilation is successful (like in other arches).

Additional info: happens on f22, f23 and rawhide.
Comment 1 Jan Kurik 2016-02-24 09:18:16 EST
This bug appears to have been reported against 'rawhide' during the Fedora 24 development cycle.
Changing version to '24'.

More information and reason for this action is here:
Comment 2 Martin Sebor 2016-03-16 15:34:42 EDT
The test case doesn't look quite right (there's no insertion operator matching std::ostream and ::vector) and doesn't compile even on x86_64.

There is a known problem with the name vector in the powerpc GCC, however: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=51654.  That coule be behind the qucs build issue.
Comment 3 Jakub Jelinek 2016-03-18 10:38:55 EDT
Tracking upstream now in PR70296.
Comment 4 Fedora End Of Life 2017-07-25 15:48:05 EDT
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.
Comment 5 Fedora End Of Life 2017-08-08 08:40:34 EDT
Fedora 24 changed to end-of-life (EOL) status on 2017-08-08. Fedora 24 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.